## csmith 2.3.0

=== CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2017 The University of Utah
## All rights reserved.
##
## This file is part of `csmith', a random generator of C programs.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are met:
##
##   * Redistributions of source code must retain the above copyright notice,
##     this list of conditions and the following disclaimer.
##
##   * Redistributions in binary form must reproduce the above copyright
##     notice, this list of conditions and the following disclaimer in the
##     documentation and/or other materials provided with the distribution.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
## AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
## IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
## ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
## LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
## CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
## SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
## INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
## CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
## ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
## POSSIBILITY OF SUCH DAMAGE.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(CheckIncludeFile)
include(CheckSymbolExists)
include(GetGitRevisionDescription)

project(csmith)

###############################################################################

# Determine the short git hash for the source tree.  The logic here follows the
# logic in the `git-hash.sh` script.
#
## METHOD 1: The source tree is the result of `git archive'.
# `git archive' inserts the abbreviated hash of the archive's commit into this
# file.  (See the `.gitattributes' file.)
#
set(GIT_HASH "$Format:%h$")
if(GIT_HASH MATCHES "^\\$")
  ## METHOD 2: The source tree is a git repository.
  get_git_head_revision(GIT_REFSPEC GIT_HASH)
  if(NOT GIT_HASH STREQUAL "GITDIR-NOTFOUND")
    # Trim to the short hash.
    string(SUBSTRING "${GIT_HASH}" 0 7 GIT_HASH)
  else()
    ## METHOD 3: Give up.
    set(GIT_HASH "unknown")
  endif()
endif()

# `arc4random' and friends are available on BSD in the standard C library, and
# on Linux in `libbsd'.  We use `arc4random_buf' if it is available, but we do
# not require it.
#
message(STATUS "Check for libbsd")
find_library(BSD_LIBRARY NAMES bsd)
if(BSD_LIBRARY)
  message(STATUS "Check for libbsd: found ${BSD_LIBRARY}")
else()
  message(STATUS "Check for libbsd: not found")
endif()

###############################################################################

# Generate the "config.h" file.
#
check_include_file("bsd/stdlib.h"	HAVE_BSD_STDLIB_H)
check_include_file("dlfcn.h"		HAVE_DLFCN_H)
check_include_file("inttypes.h"		HAVE_INTTYPES_H)
check_include_file("memory.h"		HAVE_MEMORY_H)
check_include_file("stdint.h"		HAVE_STDINT_H)
check_include_file("stdlib.h"		HAVE_STDLIB_H)
check_include_file("strings.h"		HAVE_STRINGS_H)
check_include_file("string.h"		HAVE_STRING_H)
check_include_file("sys/stat.h"		HAVE_SYS_STAT_H)
check_include_file("sys/types.h"	HAVE_SYS_TYPES_H)
check_include_file("unistd.h"		HAVE_UNISTD_H)

set(arc4random_hdrs "stdlib.h")
if(HAVE_BSD_STDLIB_H)
  list(APPEND arc4random_hdrs "bsd/stdlib.h")
endif()
if(BSD_LIBRARY)
  set(CMAKE_REQUIRED_LIBRARIES "${BSD_LIBRARY}")
endif()
check_symbol_exists(arc4random_buf
		    "${arc4random_hdrs}" HAVE_ARC4RANDOM_BUF)
set(CMAKE_REQUIRED_LIBRARIES "")

check_symbol_exists(lrand48
		    "stdlib.h"		HAVE_LRAND48)
check_symbol_exists(srand48_deterministic
		    "stdlib.h"		HAVE_SRAND48_DETERMINISTIC)

set(csmith_PACKAGE			"csmith")
set(csmith_PACKAGE_BUGREPORT		"csmith-bugs@flux.utah.edu")
set(csmith_PACKAGE_NAME			"csmith")
set(csmith_PACKAGE_STRING		"csmith 2.3.0")
set(csmith_PACKAGE_TARNAME		"csmith")
set(csmith_PACKAGE_URL			"http://embed.cs.utah.edu/csmith/")
set(csmith_PACKAGE_VERSION		"2.3.0")
set(csmith_VERSION			"2.3.0")

configure_file("cmake_config.h.in" "${PROJECT_BINARY_DIR}/config.h")
add_definitions("-DHAVE_CONFIG_H")

###############################################################################

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
    OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-long-long")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
endif()

# Locate M4, which is needed to create some of the runtime headers.
#
message(STATUS "Check for M4 macro processor")
find_program(M4
  NAMES "m4${CMAKE_EXECUTABLE_SUFFIX}" "m4${CMAKE_EXECUTABLE_SUFFIX}"
  DOC "Location of the M4 macro processor"
  )
if(NOT M4)
  message(FATAL_ERROR
    "The `m4' macro processor was not found.  "
    "You must install `m4' before you can to compile Csmith.")
endif()
message(STATUS "Check for M4 macro processor: found ${M4}")

###############################################################################

add_subdirectory(doc)
add_subdirectory(runtime)
add_subdirectory(scripts)
add_subdirectory(src)

###############################################################################

## End of file.

=== doc/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2017 The University of Utah
## All rights reserved.
##
## This file is part of `csmith', a random generator of C programs.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are met:
##
##   * Redistributions of source code must retain the above copyright notice,
##     this list of conditions and the following disclaimer.
##
##   * Redistributions in binary form must reproduce the above copyright
##     notice, this list of conditions and the following disclaimer in the
##     documentation and/or other materials provided with the distribution.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
## AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
## IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
## ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
## LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
## CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
## SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
## INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
## CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
## ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
## POSSIBILITY OF SUCH DAMAGE.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)
project(csmith_doc)

set(DOC_DIR "${CMAKE_INSTALL_PREFIX}/share/doc/csmith")

###############################################################################

install(FILES
  "probabilities.txt"
  DESTINATION "${DOC_DIR}"
  )

###############################################################################

## End of file.

=== runtime/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2017 The University of Utah
## All rights reserved.
##
## This file is part of `csmith', a random generator of C programs.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are met:
##
##   * Redistributions of source code must retain the above copyright notice,
##     this list of conditions and the following disclaimer.
##
##   * Redistributions in binary form must reproduce the above copyright
##     notice, this list of conditions and the following disclaimer in the
##     documentation and/or other materials provided with the distribution.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
## AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
## IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
## ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
## LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
## CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
## SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
## INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
## CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
## ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
## POSSIBILITY OF SUCH DAMAGE.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)
project(csmith_runtime)

cmake_policy(SET CMP0042 NEW) # Quiet warning about shared libs on OS X.

set(INCLUDE_DIR "${CMAKE_INSTALL_PREFIX}/include/csmith-${csmith_VERSION}")
set(LIB_DIR     "${CMAKE_INSTALL_PREFIX}/lib")

###############################################################################

include_directories(${CMAKE_BINARY_DIR})

# Build and install the static library.

add_library(libcsmith_a STATIC
  ${CMAKE_BINARY_DIR}/config.h
  volatile_runtime.c
  volatile_runtime.h
  )
set_target_properties(libcsmith_a PROPERTIES OUTPUT_NAME "csmith")

install(TARGETS libcsmith_a
  ARCHIVE DESTINATION "${LIB_DIR}"
  )

#####

# Build and install the shared library.

add_library(libcsmith_so SHARED
  ${CMAKE_BINARY_DIR}/config.h
  volatile_runtime.c
  volatile_runtime.h
  )
set_target_properties(libcsmith_so PROPERTIES OUTPUT_NAME "csmith")
# Set library build and API versions to mimic what the Automake-based path
# installs (for Linux).  This is probably not very useful.
set_target_properties(libcsmith_so PROPERTIES VERSION 0.0.0 SOVERSION 0)

# Linux, OS X, FreeBSD et al. look for the LIBRARY specification.
# Windows ("DLL platforms") looks for the RUNTIME specification.
# See, e.g., https://stackoverflow.com/questions/14990343/cmake-error-targets-given-no-library-destination-for-shared-library-target
install(TARGETS libcsmith_so
  LIBRARY DESTINATION "${LIB_DIR}"
  RUNTIME DESTINATION "${LIB_DIR}"
  )

###############################################################################

# Build and install the runtime headers.

set(generated_headers "")
list(APPEND generated_headers
  safe_math.h
  safe_math_macros.h
  safe_math_macros_notmp.h
  )

foreach(hdr IN LISTS generated_headers)
  string(REGEX REPLACE "[.]h$" ".m4" hdr_src ${hdr})
  add_custom_command(
    OUTPUT ${hdr}
    COMMAND ${M4} < ${PROJECT_SOURCE_DIR}/${hdr_src} > ${hdr}
    DEPENDS ${PROJECT_SOURCE_DIR}/${hdr_src}
    VERBATIM
    )
endforeach(hdr)

add_custom_target(
  headers ALL
  DEPENDS ${generated_headers}
  )

install(FILES
  csmith.h
  csmith_minimal.h
  custom_limits.h
  custom_stdint_x86.h
  platform_avr.h
  platform_generic.h
  platform_msp430.h
  random_inc.h
  safe_abbrev.h
  stdint_avr.h
  stdint_ia32.h
  stdint_ia64.h
  stdint_msp430.h
  volatile_runtime.c
  volatile_runtime.h
  DESTINATION "${INCLUDE_DIR}"
  )
foreach(hdr IN LISTS generated_headers)
  install(FILES
    "${PROJECT_BINARY_DIR}/${hdr}"
    DESTINATION "${INCLUDE_DIR}"
    )
endforeach(hdr)
install(FILES
  windows/stdint.h
  DESTINATION "${INCLUDE_DIR}/windows"
  )

###############################################################################

## End of file.

=== scripts/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2017 The University of Utah
## All rights reserved.
##
## This file is part of `csmith', a random generator of C programs.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are met:
##
##   * Redistributions of source code must retain the above copyright notice,
##     this list of conditions and the following disclaimer.
##
##   * Redistributions in binary form must reproduce the above copyright
##     notice, this list of conditions and the following disclaimer in the
##     documentation and/or other materials provided with the distribution.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
## AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
## IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
## ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
## LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
## CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
## SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
## INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
## CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
## ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
## POSSIBILITY OF SUCH DAMAGE.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)
project(csmith_scripts)

set(BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin")

###############################################################################

install(PROGRAMS
  "compiler_test.in"
  "compiler_test.pl"
  "launchn.pl"
  DESTINATION "${BIN_DIR}"
  )

###############################################################################

## End of file.

=== src/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2017 The University of Utah
## All rights reserved.
##
## This file is part of `csmith', a random generator of C programs.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are met:
##
##   * Redistributions of source code must retain the above copyright notice,
##     this list of conditions and the following disclaimer.
##
##   * Redistributions in binary form must reproduce the above copyright
##     notice, this list of conditions and the following disclaimer in the
##     documentation and/or other materials provided with the distribution.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
## AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
## IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
## ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
## LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
## CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
## SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
## INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
## CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
## ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
## POSSIBILITY OF SUCH DAMAGE.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)
project(csmith_src)

set(BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin")

###############################################################################

# Generate file "git_version.cpp".
#
configure_file("git_version.cpp.in" "git_version.cpp" @ONLY)

include_directories(${CMAKE_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}) # needed for gen'ed .cpp files

set(csmith_SOURCES
  ${CMAKE_BINARY_DIR}/config.h
  AbsExtension.cpp
  AbsExtension.h
  AbsProgramGenerator.cpp
  AbsProgramGenerator.h
  AbsRndNumGenerator.cpp
  AbsRndNumGenerator.h
  ArrayVariable.cpp
  ArrayVariable.h
  Block.cpp
  Block.h
  Bookkeeper.cpp
  Bookkeeper.h
  CFGEdge.cpp
  CFGEdge.h
  CGContext.cpp
  CGContext.h
  CGOptions.cpp
  CGOptions.h
  CVQualifiers.cpp
  CVQualifiers.h
  Common.h
  CommonMacros.h
  CompatibleChecker.cpp
  CompatibleChecker.h
  Constant.cpp
  Constant.h
  CoverageTestExtension.cpp
  CoverageTestExtension.h
  CrestExtension.cpp
  CrestExtension.h
  DFSOutputMgr.cpp
  DFSOutputMgr.h
  DFSProgramGenerator.cpp
  DFSProgramGenerator.h
  DFSRndNumGenerator.cpp
  DFSRndNumGenerator.h
  DefaultOutputMgr.cpp
  DefaultOutputMgr.h
  DefaultProgramGenerator.cpp
  DefaultProgramGenerator.h
  DefaultRndNumGenerator.cpp
  DefaultRndNumGenerator.h
  DeltaMonitor.cpp
  DeltaMonitor.h
  DepthSpec.cpp
  DepthSpec.h
  Effect.cpp
  Effect.h
  Enumerator.h
  Error.cpp
  Error.h
  Expression.cpp
  Expression.h
  ExpressionAssign.cpp
  ExpressionAssign.h
  ExpressionComma.cpp
  ExpressionComma.h
  ExpressionFuncall.cpp
  ExpressionFuncall.h
  ExpressionVariable.cpp
  ExpressionVariable.h
  ExtensionMgr.cpp
  ExtensionMgr.h
  ExtensionValue.cpp
  ExtensionValue.h
  Fact.cpp
  Fact.h
  FactMgr.cpp
  FactMgr.h
  FactPointTo.cpp
  FactPointTo.h
  FactUnion.cpp
  FactUnion.h
  Filter.cpp
  Filter.h
  Finalization.cpp
  Finalization.h
  Function.cpp
  Function.h
  FunctionInvocation.cpp
  FunctionInvocation.h
  FunctionInvocationBinary.cpp
  FunctionInvocationBinary.h
  FunctionInvocationUnary.cpp
  FunctionInvocationUnary.h
  FunctionInvocationUser.cpp
  FunctionInvocationUser.h
  KleeExtension.cpp
  KleeExtension.h
  Lhs.cpp
  Lhs.h
  LinearSequence.cpp
  LinearSequence.h
  MspFilters.cpp
  MspFilters.h
  OutputMgr.cpp
  OutputMgr.h
  PartialExpander.cpp
  PartialExpander.h
  Probabilities.cpp
  Probabilities.h
  ProbabilityTable.h
  RandomNumber.cpp
  RandomNumber.h
  RandomProgramGenerator.cpp
  Reducer.cpp
  Reducer.h
  ReducerOutputMgr.cpp
  ReducerOutputMgr.h
  SafeOpFlags.cpp
  SafeOpFlags.h
  Sequence.cpp
  Sequence.h
  SequenceFactory.cpp
  SequenceFactory.h
  SequenceLineParser.h
  SimpleDeltaRndNumGenerator.cpp
  SimpleDeltaRndNumGenerator.h
  SimpleDeltaSequence.cpp
  SimpleDeltaSequence.h
  SplatExtension.cpp
  SplatExtension.h
  Statement.cpp
  Statement.h
  StatementArrayOp.cpp
  StatementArrayOp.h
  StatementAssign.cpp
  StatementAssign.h
  StatementBreak.cpp
  StatementBreak.h
  StatementContinue.cpp
  StatementContinue.h
  StatementExpr.cpp
  StatementExpr.h
  StatementFor.cpp
  StatementFor.h
  StatementGoto.cpp
  StatementGoto.h
  StatementIf.cpp
  StatementIf.h
  StatementReturn.cpp
  StatementReturn.h
  StringUtils.cpp
  StringUtils.h
  Type.cpp
  Type.h
  Variable.cpp
  Variable.h
  VariableSelector.cpp
  VariableSelector.h
  VectorFilter.cpp
  VectorFilter.h
  git_version.h
  platform.cpp
  platform.h
  random.cpp
  random.h
  util.cpp
  util.h
  ${PROJECT_BINARY_DIR}/git_version.cpp
  )
if(NOT HAVE_LRAND48)
  include_directories(${PROJECT_SOURCE_DIR}/rand48)
  list(APPEND csmith_SOURCES
    rand48/_rand48.c
    rand48/lrand48.c
    rand48/rand48.h
    rand48/srand48.c
    )
endif()

add_executable(csmith
  ${csmith_SOURCES}
  )

if(BSD_LIBRARY)
  target_link_libraries(csmith "${BSD_LIBRARY}")
endif()

install(PROGRAMS
  "${PROJECT_BINARY_DIR}/csmith"
  DESTINATION "${BIN_DIR}"
  )

###############################################################################

## End of file.

## csmith 2.2.0

=== debian/changelog ===
csmith (2.2.0-2) unstable; urgency=medium

  [Matthias Klose]
  * Apply patches taken from Fedora:
    - Fix build on all arches by adding fallback implementation for getting
      initial seed. (Closes: #814198)
    - Use system header files.
  * Fix build on ppc64el.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 05 Mar 2016 02:42:39 +0900

csmith (2.2.0-1) unstable; urgency=low

  * Initial release. (Closes: #633762)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 14 Nov 2015 04:49:14 +0900

=== debian/control ===
Source: csmith
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Section: devel
Priority: optional
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), m4
Homepage: https://embed.cs.utah.edu/csmith/
Vcs-Git: git://anonscm.debian.org/collab-maint/csmith.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/csmith.git;a=summary

Package: csmith
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: generator of random C programs
 Csmith is a tool that can generate random C programs that statically
 and dynamically conform to the C99 standard. Thus, it is useful for
 stress-testing compilers, static analyzers, and other tools that
 process C code.

Package: libcsmith0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: generator of random C programs (runtime library)
 Csmith is a tool that can generate random C programs that statically
 and dynamically conform to the C99 standard. Thus, it is useful for
 stress-testing compilers, static analyzers, and other tools that
 process C code.
 .
 This package contains the runtime library files needed to run software
 using csmith.

Package: libcsmith-dev
Section: libdevel
Architecture: any
Depends: libcsmith0 (= ${binary:Version}), ${misc:Depends}
Description: generator of random C programs (development files)
 Csmith is a tool that can generate random C programs that statically
 and dynamically conform to the C99 standard. Thus, it is useful for
 stress-testing compilers, static analyzers, and other tools that
 process C code.
 .
 This package contains the header and development files needed to build
 programs and packages using csmith.

Package: libcsmith0-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libcsmith0 (= ${binary:Version})
Description: generator of random C programs (debugging symbols)
 Csmith is a tool that can generate random C programs that statically
 and dynamically conform to the C99 standard. Thus, it is useful for
 stress-testing compilers, static analyzers, and other tools that
 process C code.
 .
 This package contains the debugging symbols for csmith.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --dbg-package=libcsmith0-dbg

override_dh_install:
	mv debian/tmp/usr/bin/compiler_test.pl \
		debian/tmp/usr/bin/compiler_test
	mv debian/tmp/usr/bin/launchn.pl \
		debian/tmp/usr/bin/launchn
	mv debian/tmp/usr/bin/test_csmith.pl \
		debian/tmp/usr/bin/test_csmith

	dh_install

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/csmith-$1.tar.gz/,dversionmangle=s/\+dfsg// \
https://github.com/csmith-project/csmith/tags .*/v?(\d\S*)\.tar\.gz

## csmith 2.3.0

=== debian/changelog ===
csmith (2.3.0-7.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:57:37 +0000

csmith (2.3.0-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061911

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Tue, 27 Feb 2024 23:10:44 +0000

csmith (2.3.0-7) unstable; urgency=medium

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Apply multi-arch hints.
    + libcsmith-dev: Add Multi-Arch: same.

  [ Nobuhiro Iwamatsu ]
  * Update d/control
    + Bumped debhelper-compat to 13.
    + Bumped Standards-Version to 4.6.1.
    + Add 'Rules-Requires-Root: no'.
  * d/not-installed: Add file.
  * d/rules: Add '--exclude=.la' to dh's option.
  * d/copyright: Update copyright year.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 07 Dec 2022 07:01:38 +0900

csmith (2.3.0-6) unstable; urgency=medium

  * Add libsys-cpu-perl to Depends of csmith. (Closes: #913831)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Fri, 21 Dec 2018 08:26:14 +0900

csmith (2.3.0-5) unstable; urgency=medium

  * Fix Vcs-Browser Vcs-Browser and Vcs-Git.
  * Bumped Standards-Version to 4.2.1.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 30 Oct 2018 08:06:05 +0900

csmith (2.3.0-4) unstable; urgency=medium

  * Change Vcs-Browser and Vcs-Git to salsa.
  * Update Standards-Version to 4.1.4.
  * Update debhelper to 11.
  * Remove libcsmith0-dbg, dbg package is auto-generated.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Fri, 22 Jun 2018 12:37:58 +0900

csmith (2.3.0-3) unstable; urgency=medium

  * Fix debian/watch.
  * Update Standards-Version to 4.1.1.
  * Support debhelper 10.
  * Remove Priority from libcsmith0-dbg.
    Change Priority from extra to optional.
  * Remove unused patch
  * Update patches/remove_version_from_path.patch

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 21 Nov 2017 08:26:22 +0900

csmith (2.3.0-2) unstable; urgency=medium

  * Fix FTBFS on s390. (Closes: #872604)
    Add patches/fix_build_s390x.patch.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Fri, 25 Aug 2017 08:41:23 +0900

csmith (2.3.0-1) unstable; urgency=medium

  * New upstream release.
  * Update debian/control.
    Update Standards-Version to 4.0.0.
  * Update debian/patches/ppc64el.patch.
  * Remove debian/patches/secondary-archs.patch.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 03 Jul 2017 17:58:41 +0900

=== debian/control ===
Source: csmith
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Section: devel
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), m4
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/csmith
Vcs-Git: https://salsa.debian.org/debian/csmith.git
Homepage: https://embed.cs.utah.edu/csmith/

Package: csmith
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsys-cpu-perl
Description: generator of random C programs
 Csmith is a tool that can generate random C programs that statically
 and dynamically conform to the C99 standard. Thus, it is useful for
 stress-testing compilers, static analyzers, and other tools that
 process C code.

Package: libcsmith0t64
Provides: ${t64:Provides}
Replaces: libcsmith0
Breaks: libcsmith0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: generator of random C programs (runtime library)
 Csmith is a tool that can generate random C programs that statically
 and dynamically conform to the C99 standard. Thus, it is useful for
 stress-testing compilers, static analyzers, and other tools that
 process C code.
 .
 This package contains the runtime library files needed to run software
 using csmith.

Package: libcsmith-dev
Architecture: any
Section: libdevel
Depends: libcsmith0t64 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: generator of random C programs (development files)
 Csmith is a tool that can generate random C programs that statically
 and dynamically conform to the C99 standard. Thus, it is useful for
 stress-testing compilers, static analyzers, and other tools that
 process C code.
 .
 This package contains the header and development files needed to build
 programs and packages using csmith.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --exclude=.la

override_dh_install:
	mv debian/tmp/usr/bin/compiler_test.pl \
		debian/tmp/usr/bin/compiler_test
	mv debian/tmp/usr/bin/launchn.pl \
		debian/tmp/usr/bin/launchn

	dh_install

=== debian/watch ===
version=4
https://embed.cs.utah.edu/csmith/csmith-(.+).tar.gz
